############################################################################
# Infolight HTTP control server
# Copyright (c) 2006 Bo Lincoln <boli@combra.se>

# Surf to http://localhost:<port>/G to set green light
# Surf to http://localhost:<port>/Y to set yellow light
# Surf to http://localhost:<port>/R to set red light
# Can be used with e.g. "wget -t1 -q http://server:<port>/<color>" in an automatic build script
 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation;
 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS.
# IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) AND AUTHOR(S) BE LIABLE FOR ANY
# CLAIM, OR ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES 
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN 
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF 
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
# ALL LIABILITY, INCLUDING LIABILITY FOR INFRINGEMENT OF ANY PATENTS, 
# COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS, RELATING TO USE OF THIS 
# SOFTWARE IS DISCLAIMED.
############################################################################

import sys
import BaseHTTPServer
import infolight
import getopt

class InfoHTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
	def do_GET(self):
		il.Set(self.path[1])
		self.send_response(200, "OK")

if __name__ == "__main__": # Start the application
	port = 8000
	serial = "/dev/ttyUSB0"

	try:
		opts, args = getopt.getopt(sys.argv[1:], "hp:s:", [ "help", "port=", "serial=" ])
	except:
		args = []
		opts = "-h"
	for o, a in opts:
		if o in ["-h", "--help"]:
			print "Usage: %s [options]\nOptions:\n\t-h --help\t\t\tGet help\n\t-p <port> --port=<port>\t\tSet TCP/IP port to listen to (default 8000)\n\t-s <serport> --serial=<serport>\tSet Infolight serial port\n" % sys.argv[0]
			sys.exit(2)
		if o in ["-p", "--port"]:
			try:
				port = int(a)
			except:
				pass
		if o in ["-s", "--serial"]:
			serial = a

	il = infolight.InfoLight(serial)
	il.Set("G")
	server = BaseHTTPServer.HTTPServer(('', port), InfoHTTPRequestHandler)
	server.serve_forever()

	
