package Properties;

use 5.006001;
use strict;
use warnings;
use Config::IniFiles;

require Exporter;
our @ISA         = qw(Exporter);
our %EXPORT_TAGS = (
  'all' => [
    qw(
      new
      addPropertyCommandLine
      addPropertyFile
      addProperty
      getProperty
      getProperties
      )
  ]
);
our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );
our @EXPORT    = qw(
);
our $VERSION = '0.1';

my %properties; # Ok, so how on earth can you make this a member variable? TODO

sub new {
    my $class = shift;
    my $self = { };
    bless $self, $class;
    return $self;
}

sub addPropertyCommandLine
{
  # Format: -Dpropertyname1=propertyvalue1;propertyname2=propertyvalue2;...
  # -D may be omitted.

  my $self = shift;
  my $commandLine = shift;
  
  if ($commandLine =~ /^-D/)  # If it starts with -D, Then just cut it off.
  {
    $commandLine = substr($commandLine, 2);
  }
  
  my @keyvaluePairs = split(/;+/, $commandLine);
  foreach (@keyvaluePairs)
  {
    my @property = split(/=/);
    $self->addProperty($property[0], $property[1]);
  }
}

sub addPropertyFile
{
  my $self = shift;
  my $configFile = shift;
  my $cfg = new Config::IniFiles( -file => $configFile ) or die "Could not open ini file '$configFile'.";
  foreach my $section ($cfg->Sections)
  {
	   my @values = $cfg->Parameters($section);
     foreach (@values)
     {
        $self->addProperty($section .'::'. $_, $cfg->val($section, $_));
     }
	}
}

sub addProperty
{
  my $self = shift;
  my $key = shift;
  my $value = shift;
  
  #my $properties = $self->properties;
  $properties{$key} = $value;
}

sub getProperty
{
  my $self = shift;
  my $property = shift;
  my $dieIfUndef = shift;
  #my %properties = $self->properties;  
  my $result = $properties{$property};
  if (defined($result)) { return $result; }  
  if (defined($dieIfUndef)) { die "Could not find required setting \'$property\'."; }
}

sub getProperties
{
  my $self = shift;
  #return $self->properties;
  return %properties;
}

1;